"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createGenerator = void 0;
const path_1 = __importDefault(require("path"));
const handlebars_templates_1 = require("@openapi-generator-plus/handlebars-templates");
const java_jaxrs_server_generator_1 = __importStar(require("@openapi-generator-plus/java-jaxrs-server-generator"));
const createGenerator = (config, context) => {
    const myContext = Object.assign(Object.assign({}, context), { loadAdditionalTemplates: async (hbs) => {
            await handlebars_templates_1.loadTemplates(path_1.default.resolve(__dirname, '../templates'), hbs);
        }, additionalWatchPaths: () => {
            return [path_1.default.resolve(__dirname, '../templates')];
        } });
    const generatorOptions = java_jaxrs_server_generator_1.options(config, myContext);
    myContext.additionalExportTemplates = async (outputPath, doc, hbs, rootContext) => {
        const relativeResourcesOutputPath = generatorOptions.relativeResourcesOutputPath;
        if (relativeResourcesOutputPath) {
            await handlebars_templates_1.emit('beans.xml', path_1.default.join(outputPath, relativeResourcesOutputPath, 'META-INF', 'beans.xml'), Object.assign({}, rootContext), false, hbs);
        }
        if (generatorOptions.includeTests) {
            const relativeTestOutputPath = generatorOptions.relativeTestOutputPath;
            const apiPackagePath = java_jaxrs_server_generator_1.packageToPath(generatorOptions.apiPackage);
            await handlebars_templates_1.emit('tests/TestConfiguration', path_1.default.join(outputPath, relativeTestOutputPath, apiPackagePath, 'TestConfiguration.java'), Object.assign({}, rootContext), false, hbs);
        }
    };
    const aJavaGenerator = java_jaxrs_server_generator_1.default(config, myContext);
    return Object.assign(Object.assign({}, aJavaGenerator), { templateRootContext: () => {
            return Object.assign(Object.assign(Object.assign({}, aJavaGenerator.templateRootContext()), generatorOptions), { generatorClass: '@openapi-generator-plus/java-cxf-cdi-server-generator' });
        } });
};
exports.createGenerator = createGenerator;
exports.default = exports.createGenerator;
